/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package matrix;

public class Operation {
  public static int[][] addition(Matrix m1, Matrix m2) throws NullPointerException, MatrixException {
    int[][] matrix1 = m1.getMatrix();
    int[][] matrix2 = m2.getMatrix();
    int[][] matrix3;  //матрица, которая получится в результате

    if (matrix1.length != matrix2.length || matrix1[0].length != matrix2[0].length) {
      throw new MatrixException("Размерности не совпадают");
    }
    if (matrix1 == null || matrix2 == null) {
      throw new NullPointerException("Empty");
    }

    matrix3 = new int[matrix1.length][matrix1[0].length];

    for (int i = 0; i < matrix1.length; i++) {
      for (int j = 0; j < matrix1[0].length; j++) {
        matrix3[i][j] = matrix1[i][j] + matrix2[i][j];
      }
    }
    return matrix3;
  }

  public static int[][] subtraction(Matrix mat1, Matrix mat2) throws NullPointerException, MatrixException {
    int[][] matrix1 = mat1.getMatrix();
    int[][] matrix2 = mat2.getMatrix();
    int[][] matrix3;

    if (matrix1.length != matrix2.length || matrix1[0].length != matrix2[0].length) {
      throw new MatrixException("Размерности не совпадают");
    }
    if (matrix1 == null || matrix2 == null) {
      throw new NullPointerException("Empty");
    }

    matrix3 = new int[matrix1.length][matrix1[0].length];

    for (int i = 0; i < matrix1.length; i++) {
      for (int j = 0; j < matrix1[0].length; j++) {
        matrix3[i][j] = matrix1[i][j] - matrix2[i][j];
      }
    }
    return matrix3;
  }

  public static int[][] multiply(Matrix m1, Matrix m2) throws NullPointerException, MatrixException {
    int[][] matrix1 = m1.getMatrix();
    int[][] matrix2 = m2.getMatrix();
    int[][] matrix3;

    if (matrix1.length != matrix2.length || matrix1[0].length != matrix2[0].length) {
      throw new MatrixException("Размерности не совпадают");
    }
    if (matrix1 == null || matrix2 == null) {
      throw new NullPointerException("Empty");
    }

    matrix3 = new int[matrix1.length][matrix2[0].length];

    for (int i = 0; i < matrix1.length; i++) {
      for (int j = 0; j < matrix2[0].length; j++) {
        for (int l = 0; l < matrix2.length; l++) {
          matrix3[i][j] += matrix1[i][l] * matrix2[l][j];
        }
      }
    }
    return matrix3;
  }

  public void printMatrix(int[][] matrix){
    for (int i = 0; i < matrix.length; i++) {
      for (int j = 0; j < matrix[0].length; j++) {
        System.out.print(matrix[i][j] + " ");
      }
      System.out.println();
    }
    System.out.println();
  }
}
